// ----------------------------------------------------------------------------
//
// umFish40.PAS                                         Ulrich Mller  25.04.06
//                                                      PCS1700         Delphi4
// Deklarationen und Variable zu umFish40.DLL  v4.1.59.1
//
// ----------------------------------------------------------------------------

unit umFish40;

interface
const
  ftiROBO_first_USB       = 0;   ftiIntelligent_IF       = 10;
  ftiIntelligent_IF_Slave = 20;  ftiROBO_IF_IIM          = 50;
  ftiROBO_IF_USB          = 60;  ftiROBO_IF_COM          = 70;
  ftiROBO_IF_Over_RF      = 80;  ftiROBO_IO_Extension    = 90;

  ftiCOM1 = 1; ftiCOM2 = 2; ftiCOM3 = 3; ftiCOM4 = 4;

  ftiAus=0; ftiEin=1; ftiLinks=1; ftiRechts=2;
  ftiFehler=LongInt($E0000001); ftiTrue=1; ftiFalse=0;

type
    MessageData = record
      HwId  : Char;
      SubId : Char;
      MsgId : Word;
      Msg   : Word;
    end;
type pMessageData = ^MessageData;

function rbOpenInterfaceUSB(ifTyp, SerialNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbOpenInterfaceRF(SerialNrInterface: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbOpenInterfaceCOM(ifTyp, ComNrNr, AnalogZyklen: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbCloseInterface(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';

function rbGetInput(iHandle, InputNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetInputs(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetAnalog(iHandle, AnalogNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetIRKey(iHandle, Code, KeyNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetVoltage(iHandle, VoltNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';

function rbSetMotor(iHandle, MotorNr, Direction: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotorEx(iHandle, MotorNr, Direction, Speed: LongInt):LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetMotors(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotors(iHandle, MotorStatus: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotorsEx(iHandle, MotorStatus,
                       SpeedStatus, SpeedStatus16: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetModeStatus(iHandle, MotorNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetModeStatus(iHandle, MotorNr, Mode: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetLamp(iHandle, LampNr, OnOff: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetLampEx(iHandle, LampNr, OnOff, Power: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbRobMotor(iHandle, MotorNr, Direction,
                             Speed, ICount: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbRobMotors(iHandle, MotorStatus, SpeedStatus, SpeedStatus16,
                              ModeStatus:LongInt):LongInt;
                                              stdcall; external 'umFish40.DLL';

function rbGetCounter(iHandle, CounterNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetCounter(iHandle, CounterNr, ICount: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbClearCounters(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';

function rbClearMessagesIn(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbClearMessagesOut(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetMessage(iHandle: LongInt; inN: pMessageData): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSendMessage(iHandle: LongInt; outN: pMessageData): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSendMessageEx(iHandle: LongInt; outN: pMessageData;
                                  Spez: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';

function rbGetActDeviceType(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetActDeviceSerialNr(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetActDeviceFirmwareNr(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
implementation

end.
