// --------------------------------------------------------------------------------------
//
// HelloMain.CS                                                    Ulrich Mller 25.04.06
//                                                                 PCS1700   C# Final SP2
// Kleines Beispiel zur Nutzung von umFish40.DLL (v4.1.59.1) / FtLib.LIB v0.59
// ber die statischen Elemente der Klasse umFish40CS
// ROBO Interface am ersten USB-Port. Mit Taster an I1 und Motor/Lampe an M1
//
// --------------------------------------------------------------------------------------

using System;
using System.Threading;
using cs = System.Console;
using um = HelloCSROBO.umFish40CS;


namespace HelloCSROBO {
	class Rahmen {
		uint iHandle;
		[STAThread]
		static void Main(string[] args)	{
			Rahmen rt = new Rahmen();
			cs.WriteLine("--- Hello ROBO gestartet ---");
			rt.Action();
			cs.WriteLine("--- Hello ROBO beendet (Return-Taste) ---");
			cs.Read();
		}
		private void Action() {
			iHandle = um.rbOpenInterfaceUSB((int)IFTypen.ftROBO_first_USB, 0);
			if(iHandle == um.rbFehler) {
				cs.WriteLine("Da stimmt was nicht : ENDE (Return-Taste)");
				return;
			}
			cs.WriteLine("IN ACTION : Start I1 drcken");
			MessageData outN;
			outN.HwId = 2;
			outN.SubId = 1;
			outN.MsgId = 222;
			outN.Msg = 3;
			um.rbSendMessage(iHandle, ref outN);
			while(um.rbGetInput(iHandle, 1) == 0) {um.Sleep(123);};
			for(int i = 0; i < 5; i++) {
				cs.WriteLine("Blinker : " + i);
				um.rbSetMotor(iHandle, 1, 1);
				um.Sleep(333);
				um.rbSetMotor(iHandle, 1, 0);
				um.Sleep(333);
			}
			umFish40CS.rbCloseInterface(iHandle);
		}
	}
}
