// --------------------------------------------------------------------------------------
//
// umFish40CS.CS                                                   Ulrich Mller 25.04.06
//                                                                 PCS1700   C# Final SP2
// Statische Klasse mit umFish40.DLL Deklarationen v4.1.59.1
//
// --------------------------------------------------------------------------------------

using System;
using System.Runtime.InteropServices;


namespace HelloCSROBO {

	public enum IFTypen {
		ftROBO_first_USB       = 0,
		ftIntelligent_IF       = 10,
		ftIntelligent_IF_Slave = 20,
		ftROBO_IF_IIM          = 50,
		ftROBO_IF_USB          = 60,
		ftROBO_IF_COM          = 70,
		rfROBO_IF_Over_RF      = 80,
		ftROBO_IO_Extension    = 90,
		ftROBO_RF_Datalink     = 110
	}

	public struct MessageData {
		public byte HwId;
		public byte SubId;
		public ushort MsgId;
		public ushort Msg;
	}

	public class umFish40CS	{

		public umFish40CS()	{}

		// --- umFish40.DLL Deklarationen ----------------------------------------
		[DllImport("umFish40.DLL")]
		public static extern uint rbOpenInterfaceUSB(int ifTyp, int SerialNr);
		[DllImport("umFish40.DLL")]
		public static extern uint rbOpenInterfaceRF(int SerialNrInterface);
		[DllImport("umFish40.DLL")]
		public static extern uint rbOpenInterfaceCOM(int ifTyp, 
			int ComNr, int AnalogZyklen);
		[DllImport("umFish40.DLL")]
		public static extern uint rbCloseInterface(uint iHandle);
		
		[DllImport("umFish40.DLL")]
		public static extern int rbGetInput(uint iHandle, int InputNr);
		[DllImport("umFish40.DLL")]
		public static extern int rbGetInputs(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern int rbGetAnalog(uint iHandle, int AnalogNr);
		[DllImport("umFish40.DLL")]
		public static extern int rbGetIRKey(uint iHandle, int Code, int KeyNr);
		[DllImport("umFish40.DLL")]
		public static extern int rbGetVoltage(uint iHandle, int VoltNr);
		
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetMotor(uint iHandle, int MotNr, int Dir);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetMotorEx(uint iHandle, 
			int MotNr, int Dir, int Speed);
		[DllImport("umFish40.DLL")]
		public static extern int rbGetMotors(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetMotors(uint iHandle, int MotorStatus);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetMotorsEx(uint iHandle, int MotorStatus,
			int SpeedStatus, int SpeedStatus16);
		[DllImport("umFish40.DLL")]
		public static extern int rbGetModeStatus(uint iHandle, int MotNr);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetModeStatus(uint iHandle, int MotNr, int Mode);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetLamp(uint iHandle, int LampNr, int OnOff);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetLampEx(uint iHandle, 
			int LampNr, int OnOff, int Power);
		[DllImport("umFish40.DLL")]
		public static extern uint rbRobMotor(uint iHandle, 
			int MotNr, int Dir, int Speed, int ICount);
		[DllImport("umFish40.DLL")]
		public static extern uint rbRobMotors(uint iHandle, 
			int MotorStatus, uint SpeedStatus, int SpeedStatus16, int ModeStatus);
		
		[DllImport("umFish40.DLL")]
		public static extern int rbGetCounter(uint iHandle, int CounterNr);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSetCounter(uint iHandle, int CounterNr, int ICount);
		[DllImport("umFish40.DLL")]
		public static extern uint rbClearCounters(uint iHandle);

		[DllImport("umFish40.DLL")]
		public static extern uint rbClearMessagesIn(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern uint rbClearMessagesOut(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern uint rbGetMessage(uint iHandle, out MessageData inMessage);
		[DllImport("umFish40.DLL")]
		public static extern uint rbIsMessage(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSendMessage(uint iHandle, ref MessageData outMessage);
		[DllImport("umFish40.DLL")]
		public static extern uint rbSendMessageEx(uint iHandle, ref MessageData outMessage, int Spez);

		[DllImport("umFish40.DLL")]
		public static extern uint rbGetActDeviceType(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern uint rbGetActDeviceSerialNr(uint iHandle);
		[DllImport("umFish40.DLL")]
		public static extern uint rbGetActDeviceFirmwareNr(uint iHandle);

		public const uint rbFehler = 0xE0000001;

		// --- Win API Deklarationen ----------------------------------------------------

		[DllImport("kernel32")]
		public static extern void Sleep(uint mSek);
		[DllImport("kernel32")]
		public static extern uint GetTickCount();
		[DllImport("user32")]
		public static extern uint GetAsyncKeyState(uint vKey);
		public const uint ESCAPE = 0x1B;
	}
}
