' --------------------------------------------------------------------------------------
'
' umFish40VBNET.VB                                                Ulrich Mller 25.04.06
'                                                                 PCS1700   VB.NET Final
' Deklarationen zur Nutzung von umFish40.DLL (v4.1.59.1) / FtLib.LIB (v0.59)
'
' --------------------------------------------------------------------------------------

  Public Enum IFTypen As Integer
    ftROBO_first_USB = 0
    ftIntelligent_IF = 10
    ftIntelligent_IF_Slave = 20
    ftROBO_IF_IIM = 50
    ftROBO_IF_USB = 60
    ftROBO_IF_COM = 70
    rfROBO_IF_Over_RF = 80
    ftROBO_IO_Extension = 90
    ftROBO_RF_Datalink = 110
    End Enum

Public Structure MessageData
  Public HwId As Byte
  Public SubId As Byte
  Public MsgId As Short
  Public Msg As Short
End Structure

Public Class umFish40VBNET

' --- umFish40.DLL Deklarationen ----------------------------------------

  Public Declare Function rbOpenInterfaceUSB Lib "umFish40.DLL" _
    (ByVal ifTyp%, ByVal SeriarNr%) As Integer
  Public Declare Function rbOpenInterfaceRF Lib "umFish40.DLL" _
    (ByVal SerialNrInterface%) As Integer
  Public Declare Function rbOpenInterfaceCOM Lib "umFish40.DLL" _
    (ByVal ifTyp%, ByVal ComNr%, ByVal AnalogZyklen%) As Integer
  Public Declare Function rbCloseInterface Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
' --- I- und A-Eingnge ----------------
  Public Declare Function rbGetInput Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal InputNr%) As Integer
  Public Declare Function rbGetInputs Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbGetAnalog Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal AnalogNr%) As Integer
  Public Declare Function rbGetIRKey Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal Code%, ByVal KeyNr%) As Integer
  Public Declare Function rbGetVoltage Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal VoltNr%) As Integer

' --- M- und O-Ausgnge ---------------
  Public Declare Function rbSetMotor Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotNr%, ByVal Dir%) As Integer
  Public Declare Function rbSetMotorEx Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotNr%, ByVal Dir%, ByVal Speed%) As Integer
  Public Declare Function rbGetMotors Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbSetMotors Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotorStatus%) As Integer
  Public Declare Function rbSetMotorsEx Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotorStatus%, ByVal SpeedStatus%, _
                                           ByVal SpeedStatus16%) As Integer
  Public Declare Function rbGetModeStatus Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotNr%) As Integer
  Public Declare Function rbSetModeStatus Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotNr%, ByVal Mode%) As Integer
  Public Declare Function rbSetLamp Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal LampNr%, ByVal OnOff%) As Integer
  Public Declare Function rbSetLampEx Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal LampNr%, ByVal OnOff%, ByVal Power%) As Integer
  Public Declare Function rbRobMotor Lib "umFish40.DLL" _
    (ByVal iHandle%, ByVal MotNr%, ByVal Dir%, ByVal Speed%, ByVal ICount%) As Integer
  Public Declare Function rbRobMotors Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal MotorStatus%, ByVal SpeedStatus%, _
                       ByVal SpeedStatus16%, ByVal ModeStatus%) As Integer

' --- ImpulsCounter ------------------
  Public Declare Function rbGetCounter Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal CounterNr%) As Integer
  Public Declare Function rbSetCounter Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal CounterNr%, ByVal ICount%) As Integer
  Public Declare Function rbClearCounters Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer

' --- Nachrichten ------------------------
  Public Declare Function rbClearMessagesIn Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbClearMessageOut Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbGetMessage Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal inMessage As MessageData) As Integer
  Public Declare Function rbIsMessage Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbSendMessage Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal outMessage As MessageData) As Integer
  Public Declare Function rbSendMessageEx Lib "umFish40.DLL" _
      (ByVal iHandle%, ByVal outMessage As MessageData, ByVal Spez%) As Integer

' --- Auskunftsfunktionen-----------------
  Public Declare Function rbGetActDeviceType Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbGetActDeviceSerialNr Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer
  Public Declare Function rbGetActDeviceFirmwareNr Lib "umFish40.DLL" _
      (ByVal iHandle%) As Integer

  Public Const rbFehler = &HE0000001

' --- Win API Deklarationen ----------------------------------------------------

  Public Declare Sub Sleep Lib "kernel32" (ByVal mSek%)
  Public Declare Function GetTickCount Lib "kernel32" () As Integer
  Public Declare Function GetAsyncKeyState Lib "kernel32" (ByVal vKey%) As Integer
  Public Const ESCAPE = &H1B

End Class
