// -----------------------------------------------------------------------------
//
// umFish40.H                                             Ulrich Mller 23.04.06
//                                                        PCS1700       VC++ 6.0
// Definitionen und Deklarationen zu umFish40.CPP
// 
// -----------------------------------------------------------------------------

#include "FtLib.h"

typedef struct {
	FT_HANDLE           ftHandle;
	FT_TRANSFER_AREA*   ftDCB;
	NOTIFICATION_EVENTS ftEvents;
	DWORD               mModeStatus;
	DWORD               iStatusAlt;
	int                 iCounter[32];
} RoboInstanz;

typedef struct {
	BYTE HwId;
	BYTE SubId;
	USHORT MsgId;
	USHORT Msg;
} MessageData;

int    __stdcall rbOpenInterfaceUSB(int ifTyp, int SerialNr);
int    __stdcall rbOpenInterfaceRF(int SerialNrInterface);
int    __stdcall rbOpenInterfaceCOM(int ifTyp, int ComNr, int AnalogZyklen);
int    __stdcall rbCloseInterface(int iHandle);

int    __stdcall rbGetInput(int iHandle, int InputNr);
int    __stdcall rbGetInputs(int iHandle);
int    __stdcall rbGetAnalog(int iHandle, int AnalogNr);
int    __stdcall rbGetIRKey(int Handle, int Code, int KeyNr);
int    __stdcall rbGetVoltage(int iHandle, int VoltNr);

int    __stdcall rbSetMotor(int iHandle, int MotNr, int Dir);
int    __stdcall rbSetMotorEx(int iHandle, int MotNr, int Dir, int Speed);
int    __stdcall rbGetMotors(int iHandle);
int    __stdcall rbSetMotors(int iHandle, int MotorStatus);
int    __stdcall rbSetMotorsEx(int iHandle, int MotorStatus, 
														int SpeedStatus, int SpeedStatus16);
int    __stdcall rbGetModeStatus(int iHandle, int MotNr);
int    __stdcall rbSetModeStatus(int iHandle, int MotNr, int Mode);
int    __stdcall rbSetLamp(int iHandle, int LampNr, int OnOff);
int    __stdcall rbSetLampEx(int iHandle, int LampNr, int OnOff, int Power);
int    __stdcall rbRobMotor(int iHandle, int MotNr, int Dir, int Speed, int ICount);
int    __stdcall rbRobMotors(int iHandle, int MotorStatus, 
			    									int SpeedStatus, int SpeedStatus16, int ModeStatus);

int    __stdcall rbGetCounter(int iHandle, int CounterNr);
int    __stdcall rbSetCounter(int iHandle, int CounterNr, int ICount);
int    __stdcall rbClearCounters(int iHandle);

int    __stdcall rbClearMessagesIn(int Handle);
int    __stdcall rbClearMessagesOut(int iHandle);
int    __stdcall rbGetMessage(int iHandle, MessageData* inN);
int    __stdcall rbIsMessage(int iHandle);
int    __stdcall rbSendMessage(int iHandle, MessageData* outN);
int    __stdcall rbSendMessageEx(int iHandle, MessageData* outN, int Spez);

int    __stdcall rbGetActDeviceType(int iHandle);
int    __stdcall rbGetActDeviceSerialNr(int iHandle);
int    __stdcall rbGetActDeviceFirmwareNr(int iHandle);
LPCSTR __stdcall rbGetActDeviceFirmware(int iHandle);
LPCSTR __stdcall rbGetActDeviceName(int iHandle);


#define ftiAus    0
#define ftiEin    1
#define ftiLinks  1
#define ftiRechts 2
#define ftiAX     1
#define ftiAY     2
#define ftiAXS1   3
#define ftiAXS2   4
#define ftiAXS3   5
#define ftiA1     1
#define ftiA2     2
#define ftiAV     3

const UCHAR  MAus[4]    = {0xFC, 0xF3, 0xCF, 0x3F};
const UCHAR  MLinks[4]  = {0x01, 0x04, 0x10, 0x40};
const UCHAR  MRechts[4] = {0x02, 0x08, 0x20, 0x80};
const DWORD  EMaske[32] = {0x00000001, 0x00000002, 0x00000004, 0x00000008, 
                           0x00000010, 0x00000020, 0x00000040, 0x00000080,
                           0x00000100, 0x00000200, 0x00000400, 0x00000800,
                           0x00001000, 0x00002000, 0x00004000, 0x00008000,
                           0x00010000, 0x00020000, 0x00040000, 0x00080000,
                           0x00100000, 0x00200000, 0x00400000, 0x00800000,
                           0x01000000, 0x02000000, 0x04000000, 0x08000000,
                           0x10000000, 0x20000000, 0x40000000, 0x80000000};
const DWORD  MMaske[16] = {0x00000003, 0x0000000C, 0x00000030, 0x000000C0,
                           0x00000300, 0x00000C00, 0x00003000, 0x0000C000,
                           0x00030000, 0x000C0000, 0x00300000, 0x00C00000,
                           0x03000000, 0x0C000000, 0x30000000, 0xC0000000};
