// -----------------------------------------------------------------------------
//
// umFish40VC.H                                           Ulrich Mller 23.04.06
//                                                        PCS1700       VC++ 6.0
// Deklarationen und Definitionen fr den Einsatz von umFish40.DLL
// 19.3.06 : Version 4.1 Mit Communication zwischen RF Datalink und zugeordnetem
//           ROBO Interface RF 2/1 und weiteren RF 2/2 ....
// 23.4.06 : FtLib v0.59
//
// -----------------------------------------------------------------------------

#include <Windows.h>

#define rbFehler 0xE0000001L

typedef struct {
	BYTE HwId;
	BYTE SubId;
	USHORT MsgId;
	USHORT Msg;
} MessageData;

int __stdcall rbOpenInterfaceUSB(int ifTyp, int SerialNr);
int __stdcall rbOpenInterfaceRF(int SerialNrInterface);
int __stdcall rbOpenInterfaceCOM(int ifTyp, int ComNr, int AnalogZyklen);
int __stdcall rbCloseInterface(int iHandle);

int __stdcall rbGetInput(int iHandle, int InputNr);
int __stdcall rbGetInputs(int iHandle);
int __stdcall rbGetAnalog(int iHandle, int AnalogNr);
int __stdcall rbGetIRKey(int Handle, int Code, int KeyNr);
int __stdcall rbGetVoltage(int iHandle, int VoltNr);

int __stdcall rbSetMotor(int iHandle, int MotNr, int Dir);
int __stdcall rbSetMotorEx(int iHandle, int MotNr, int Dir, int Speed);
int __stdcall rbGetMotors(int iHandle);
int __stdcall rbSetMotors(int iHandle, int MotorStatus);
int __stdcall rbSetMotorsEx(int iHandle, int MotorStatus, 
														int SpeedStatus, int SpeedStatus16);
int __stdcall rbGetModeStatus(int iHandle, int MotNr);
int __stdcall rbSetModeStatus(int iHandle, int MotNr, int Mode);
int __stdcall rbSetLamp(int iHandle, int LampNr, int OnOff);
int __stdcall rbSetLampEx(int iHandle, int LampNr, int OnOff, int Power);
int __stdcall rbRobMotor(int iHandle, int MotNr, int Dir, int Speed, int ICount);
int __stdcall rbRobMotors(int iHandle, int MotorStatus, 
													int SpeedStatus, int SpeedStatus16, int ModeStatus);

int __stdcall rbGetCounter(int iHandle, int CounterNr);
int __stdcall rbSetCounter(int iHandle, int CounterNr, int ICount);
int __stdcall rbClearCounters(int iHandle);

int    __stdcall rbClearMessagesIn(int Handle);
int    __stdcall rbClearMessagesOut(int iHandle);
int    __stdcall rbGetMessage(int iHandle, MessageData* inN);
int    __stdcall rbIsMessage(int iHandle);
int    __stdcall rbSendMessage(int iHandle, MessageData* outN);
int    __stdcall rbSendMessageEx(int iHandle, MessageData* outN, int Spez);

int    __stdcall rbGetActDeviceType(int iHandle);
int    __stdcall rbGetActDeviceSerialNr(int iHandle);
int    __stdcall rbGetActDeviceFirmwareNr(int iHandle);
LPCSTR __stdcall rbGetActDeviceFirmware(int iHandle);
LPCSTR __stdcall rbGetActDeviceName(int iHandle);

